<template>
    <popup id="register" ref="popup">
        <div class="d-flex align-items-center mb-3">
            <h5 class="modal-title font-weight-bold">Daftar</h5>
            <a href="javascript:void(0)" class="ml-auto text-sm" @click.prevent="login()">Masuk</a>
        </div>
        <form action="#" @submit.prevent="registerSumbit()">
            <div class="form-group">
                <label for="email" class="text-sm font-weight-bold mb-0">Email Anda</label>
                <div v-if="nextStep == 1">
                    <input type="text" class="form-control-plaintext text-sm py-0 mr-2" :value="username" readonly>
                    <span class="d-block form-text text-muted text-sm">Kode verifikasi telah dikirimkan melalui Email</span>
                </div>
                <div v-else>
                    <input type="text" class="form-control" v-model="username">
                    <p class="form-text text-muted text-sm">Contoh: robertdedjumadilakir@gmail.com</p>
                </div>
            </div>
            <div class="form-group" v-if="nextStep == 1" v-cloak>
                <label for="vcode" class="text-sm font-weight-bold">Masukan Kode Verifikasi</label>
                <div class="input-code">
                    <input type="text" v-model="vcode[0]" @click="onSelect" @keyup="goToNextInput" @keydown="onKeyDown" maxlength="1" size="1" min="0" max="9" pattern="[0-9]{1}">
                    <input type="text" v-model="vcode[1]" @click="onSelect" @keyup="goToNextInput" @keydown="onKeyDown" maxlength="1" size="1" min="0" max="9" pattern="[0-9]{1}">
                    <input type="text" v-model="vcode[2]" @click="onSelect" @keyup="goToNextInput" @keydown="onKeyDown" maxlength="1" size="1" min="0" max="9" pattern="[0-9]{1}">
                    <input type="text" v-model="vcode[3]" @click="onSelect" @keyup="goToNextInput" @keydown="onKeyDown" maxlength="1" size="1" min="0" max="9" pattern="[0-9]{1}">
                </div>
            </div>
            <div class="form-group" v-if="nextStep == 1" v-cloak>
                <div class="text-muted text-sm">
                    Tidak menerima kode verifikasi ? <a href="javascript:void(0)" @click.prevent="sendVerificationCode()">kirim ulang</a>
                </div>
            </div>
            <div class="form-group">
                <button type="submit" class="btn btn-block btn-primary my-4" ref="verbtn">{{ nextStep == 1 ? 'Verifikasi' : 'Selanjutnya' }}</button>
            </div>
        </form>
        <p class="text-sm text-muted mb-0">
            Sudah punya akun Kompetensi Guru? <a href="javascript:void(0)" @click.prevent="login()">Masuk</a>
        </p>
    </popup>
</template>

<script>
import Popup from './Popup'

export default {
    components: {
        'popup': Popup
    },
    data() {
        return {
            nextStep: 0,
            username: '',
            password: '',
            isPasswdShow: false,
            vcode: [null,null,null,null]
        }
    },
    methods: {
        reset() {
            this.nextStep = 0;
            this.username = '';
            this.password = '';
            this.isPasswdShow = false;
            this.$refs.verbtn.disabled = false;
            this.vcode = [null,null,null,null];
        },
        goToNextInput(event) {
            var body = $('body'),
            key = event.which,
            t = $(event.target),
            sib = t.next('input');

            if (key != 9 && (key < 48 || key > 57)) {
                event.preventDefault();
                return false;
            }

            if (key === 9) {
                return true;
            }

            if (!sib || !sib.length) {
                sib = body.find('input').eq(0);
                this.$nextTick(() => {
                    $('.input-code input').blur();
                    this.$refs.verbtn.disabled = false;
                    this.$refs.verbtn.focus();
                });
            }
            sib.select().focus();
        },
        onKeyDown(event) {
            var key = event.which;

            if (key === 9 || (key >= 48 && key <= 57)) {
                return true;
            }

            event.preventDefault();
            return false;
        },
        onSelect(event) {
            event.target.select();
        },
        login() {
            this.reset();
            $('#register').modal('hide');
            $('#login').modal('show');
        },
        registerSumbit() {
            // Check email is valid
            if (this.username != '' && this.nextStep == 0) {

                // this.$refs.popup.loading();
                // TODO: check email address is already exist using ajax
                this.nextStep = 1;
                this.$refs.verbtn.disabled = true;
                // this.$refs.popup.stopLoading();
            }
            else {
                // TODO: ajax to post verification code
                $('#register').modal('hide');
                $('#popup-register-password').modal('show');
            }
        },
        sendVerificationCode() {
            // TODO: send new verification code
        },
        showPasswd() {
            if (this.isPasswdShow) {
                this.$refs.password.type = 'password';
                this.isPasswdShow = false;
            } else {
                this.$refs.password.type = 'text';
                this.isPasswdShow = true;
            }
        }
    }
}
</script>
